from discord import Member

from jarvis.db.types import Mute, Setting


class MemberEventHandler(object):
    def __init__(self, bot):
        self.bot = bot
        self.bot.add_listener(self.on_member_join)

    async def on_member_join(self, user: Member):
        guild = user.guild
        mutes = Mute.get_active(guild=guild.id)
        if mutes and len(mutes) >= 1:
            mute_role = Setting.get(guild=guild.id, setting="mute")
            role = guild.get_role(mute_role.value)
            await user.add_roles(
                role, reason="User is muted still muted from prior mute"
            )
        unverified = Setting.get(guild=guild.id, setting="unverified")
        if unverified:
            role = guild.get_role(unverified.value)
            await user.add_roles(
                role, reason="User just joined and is unverified"
            )
